<?xml version="1.0" encoding="UTF-8"?>
<project basedir="." name="" default="runPublic"  xmlns:if="ant:if">
    <property name="shared.folder" value="test"/>
  <target name="buildImages">      
      <property file="local.properties"/>    
      
      <docker-build dir="server" tag="protege-3.5/server"/>
      <docker-build dir="public" tag="protege-3.5/base" />
      <docker-build dir="marcus-prod-volume" tag="protege-3.5/data" args1="--build-arg SVNUSER=${SVNUSER} --build-arg SVNPWD=${SVNPWD} --build-arg SVNURI=${SVNURI}"/>
     <!-- <docker-build dir="production" tag="protege-3.5/protege-update" />-->
      <!-- jena, sparqlQueries, marcus-shellfiles, marcus-transformations-->
  </target>
    
    <target name="buildDataImage">
        <docker-build/> 
    </target>
    <target name="runPublic" depends="buildImages">
        <docker-stop name="protege-public"/>
        <docker-run name="update"/>
        <docker-stop name="update"/>
        <docker-run name="protege-public"/>
        
        <exec executable="docker">
            <arg value="run"/>
            <arg value="-d"/>
            <arg value="-p5100:5100"/>
            <arg value="-p5200:5200"/>
            <arg value="--name"/>
            <arg value="protege-public"/>
            <arg value="protege-3.5/base"/>
        </exec>
    </target>
    
   
  
    <target name="runShared" depends="buildImages">
        <docker-stop name="protege-shared"/>
        <docker-rm name="protege-shared"/>   
        
        <exec executable="docker">
            <arg value="run"/>
            <arg value="-d"/>
            <arg value="-p5100:5100"/>
            <arg value="-p5200:5200"/>
            <arg value="-v"/>
            <arg value="${shared.folder}:/data/protege-projects/marcus-bs"/>
            <arg value="--name"/>
            <arg value="protege-shared"/>
            <arg value="protege-3.5/server"/>
        </exec>
        
    </target>
      
    <target name="runProtegeServer">
        <exec dir="server" executable="docker">
            <arg value="rm"/>
            <arg value="protege-server"/>             
        </exec>
        
     
    </target>
    
    <!-- Extract to macrodef lib??-->
    <macrodef name="docker-build">
        <attribute name="dir"  default="${basedir}" description="folder to run docker build from, defaults to basedir of not set."/>        
        <attribute name="tag" description="tag of form name/name"/>  
        <attribute name="args1" default="false" description="tag of form name/name"/>
               <sequential>
            <condition property="build.arg">
                <not>
                    <equals arg1="@{args1}" arg2="false"/>
                </not>
            </condition>
                   
            <exec dir="@{dir}" executable="docker" failonerror="true">                
                <arg value="build"/>                
                <arg value="."/>                
                <arg value="-t"/>
                <arg value="@{tag}"/>
                <arg line="@{args1}" if:set="build.arg"/>                
            </exec>
            <echo message="test"/>
        </sequential>
    </macrodef>
    
    <macrodef name="docker-rm">
        <attribute name="name" description="name or id for container to rm"/>
        <sequential>
            <exec executable="docker">
                <arg value="rm"/>
                <arg value="@{name}"/>
            </exec>
        </sequential>
    </macrodef>
    
    <macrodef name="docker-stop">
        <attribute name="name" description="name or id for container to rm"/>
        <sequential>
            <exec executable="docker">
                <arg value="stop"/>
                <arg value="@{name}"/>
            </exec>
        </sequential>
    </macrodef>
    
</project>